<template>
  <div>
    <h2>{{ modulesCategories.libelle }}</h2>
    <!-- modal loader -->
    <v-layout row justify-center>
      <v-dialog v-model="dialogLoader" persistent max-width="400">
        <v-progress-linear :indeterminate="true"></v-progress-linear>
      </v-dialog>
    </v-layout>

    <!-- modal delete -->
    <v-layout row justify-center>
      <v-dialog v-model="dialogDelete" persistent max-width="290">
        <v-card>
          <v-card-title class="headline justify-center">Supprimer cette catégorie ?</v-card-title>
          <v-card-text>
            <v-btn outline color="red darken-1" flat @click="deleteCategorie()">Oui</v-btn>
            <v-btn outline color="green darken-1" flat @click="dialogDelete = false">Non</v-btn>
          </v-card-text>
        </v-card>
      </v-dialog>
    </v-layout>

    <!-- modal editer -->
    <v-layout row justify-center>
      <v-dialog v-model="dialogEdit" persistent max-width="290">
        <v-card>
          <v-card-title class="headline justify-center">Editer cette catégorie ?</v-card-title>
          <v-card-text>
            <v-text-field v-model="selectedLibelle" label="Libellé" required></v-text-field>
            <v-btn outline color="orange darken-1" flat @click="editCategorie()">Editer</v-btn>
            <v-btn outline color="grey darken-1" flat @click="dialogEdit = false">Annuler</v-btn>
          </v-card-text>
        </v-card>
      </v-dialog>
    </v-layout>

    <!-- modal ajout SOUS CATEGORIE -->
    <v-layout row justify-center>
      <v-dialog v-model="dialogAdd" persistent max-width="290">
        <v-card>
          <v-card-title class="headline justify-center">Ajouter une sous-catégorie ?</v-card-title>
          <v-card-text>
            <v-text-field v-model="newLibelle" label="Libellé" required></v-text-field>
            <v-btn outline color="orange darken-1" flat @click="addSousCategorie()">Ajouter</v-btn>
            <v-btn outline color="grey darken-1" flat @click="dialogAdd = false">Annuler</v-btn>
          </v-card-text>
        </v-card>
      </v-dialog>
    </v-layout>

    <!-- modal ajout CATEGORIE -->
    <v-layout row justify-center>
      <v-dialog v-model="dialogAddCat" persistent max-width="290">
        <v-card>
          <v-card-title class="headline justify-center">Ajouter une catégorie ?</v-card-title>
          <v-card-text>
            <v-text-field v-model="newLibelle" label="Libellé" required></v-text-field>
            <v-btn outline color="orange darken-1" flat @click="addCategorie()">Ajouter</v-btn>
            <v-btn outline color="grey darken-1" flat @click="dialogAddCat = false">Annuler</v-btn>
          </v-card-text>
        </v-card>
      </v-dialog>
    </v-layout>
    <v-layout row wrap>
      <v-btn color="success" @click="showAddModalCat()"> <i class="material-icons">add_box</i>&nbsp;Ajouter une catégorie </v-btn>
      <v-flex xs12>
        <sl-vue-tree v-model="nodes" ref="slVueTree" @select="nodeSelected" @drop="nodeDropped">
          <template slot="title" slot-scope="{ node }">
            <div class="categorie-ligne-actions">
              <v-btn color="error" fab small @click="showDeleteModal">
                <i class="material-icons">delete_forever</i>
              </v-btn>

              <v-btn color="info" fab small @click="showEditModal(node)">
                <i class="material-icons">settings</i>
              </v-btn>
              <v-btn color="success" fab small @click="showAddModal(node)" v-if="node.level < 4">
                <i class="material-icons">playlist_add</i>
              </v-btn>
              <v-btn color="grey lighten-2" fab small v-else>
                <i class="material-icons">not_interested</i>
              </v-btn>

              <v-btn class="white--text" color="cyan darken-1" fab small v-if="!node.data || node.data.visible !== false" @click="toggleVisibility($event, node)">
                <i class="material-icons">visibility</i>
              </v-btn>

              <v-btn class="white--text" color="cyan darken-4" fab small v-if="node.data && node.data.visible === false" @click="toggleVisibility($event, node)">
                <i class="material-icons">visibility_off</i>
              </v-btn>
            </div>
            <span>{{ node.title }}</span>
          </template>

          <template slot="toggle" slot-scope="{ node }">
            <span v-if="node.children.length > 0">
              <i v-if="node.isExpanded" class="material-icons">keyboard_arrow_up</i>
              <i v-if="!node.isExpanded" class="material-icons">keyboard_arrow_down</i>
            </span>

            <span v-else>
              <i class="material-icons">keyboard_arrow_right</i>
            </span>
          </template>

          <template slot="draginfo">{{ selectedNodesTitle }}</template>
        </sl-vue-tree>
      </v-flex>
    </v-layout>
    <!-- <div class="json-preview" style="text-align:left">
      <pre>{{ JSON.stringify(nodes, null, 4)}}</pre>
    </div>-->
  </div>
</template>
<script>
const URL_API = process.env.VUE_APP_URL_DISTANT_API;
const URL_UPDATE_CATEGORIES_LIST = URL_API + "api/update-categories-list-from-name/";
const URL_CATEGORIES_LIST_FROM = URL_API + "api/categories-from-name/";
import SlVueTreeComponent from "./SlVueTreeComponent";
// import jsonConfig from "@/config-data/config-products.json";
// import axios from "axios";
import slugme from "slugme";
import SlVueTree from "sl-vue-tree";
export default {
  props: ["modulesCategories", "fiche"],
  beforeMount: function() {
    this.fetchCategories();
  },
  mounted() {
    window.slVueTree = this.$refs.slVueTree;
  },
  components: {
    "sl-vue-tree": SlVueTree
  },
  data() {
    return {
      nodes: [],
      jsonNodes: {},
      contextMenuIsVisible: false,
      lastEvent: "No last event",
      selectedNodesTitle: "",

      selectedLibelle: "",
      newLibelle: "",
      newNode: {},

      //modals
      dialogDelete: false,
      dialogEdit: false,
      dialogAdd: false,
      dialogAddCat: false,
      dialogLoader: false
    };
  },
  methods: {
    fetchCategories() {
      //récupération de la liste des catégories
      this.$axios
        // .get(URL_CATEGORIES_LIST_FROM + "categories-news") // passer le param
        .get(URL_CATEGORIES_LIST_FROM + this.modulesCategories.slug) // passer le param
        .then(response => {
          //construction de la liste des données du module (news)
          if (response.data.data.length > 0) {
            response.data.data.forEach(el => {
              let tempnode = JSON.parse(el.data);
              this.nodes.push(tempnode.categories);
              this.nodes = JSON.parse(this.nodes);
            });
          }

          // this.nodes = JSON.parse(this.nodes);
        })
        .catch(error => {
          console.log("error = ", error);
        });
    },
    constructDataList(rowCat) {
      //this.nodes = rowCat;
    },
    showDeleteModal(e) {
      e.preventDefault();
      this.dialogDelete = true;
    },
    showVisibilityModal(n) {
      let slVueTree = this.$refs.slVueTree;
      let selectedNode = slVueTree.getSelected()[0];
      slVueTree.updateNode(selectedNode.path, {
        title: this.selectedLibelle,
        slug: this.string_to_slug(this.selectedLibelle)
      });

      this.dialogVisibility = true;
    },
    showEditModal(noeud) {
      this.selectedLibelle = noeud.title;
      this.dialogEdit = true;
    },
    showAddModal(noeud) {
      this.dialogAdd = true;
    },
    showAddModalCat() {
      this.dialogAddCat = true;
    },

    deleteCategorie() {
      this.dialogLoader = true;
      const slVueTree = this.$refs.slVueTree;
      const paths = slVueTree.getSelected().map(node => node.path);
      slVueTree.remove(paths);
      this.dialogDelete = false;
      this.enrNodes();
      // pour gestion produit
      // a isoler avec une conditionnelle si dedans gestion catégories
      if (this.fiche) {
        this.$emit("onCategoriesChange", true);
      }
    },
    editCategorie() {
      this.dialogLoader = true;
      let slVueTree = this.$refs.slVueTree;
      let selectedNode = slVueTree.getSelected()[0];
      slVueTree.updateNode(selectedNode.path, {
        title: this.selectedLibelle,
        slug: this.string_to_slug(this.selectedLibelle)
      });

      this.dialogEdit = false;
      this.selectedLibelle = "";
      this.newLibelle = "";
      this.enrNodes();
    },
    addCategorie() {
      this.dialogLoader = true;
      let newNode = {};
      newNode.title = this.newLibelle;
      newNode.slug = this.string_to_slug(newNode.title);
      newNode.children = [];
      newNode.isExpanded = true;
      this.nodes.push(newNode);
      // this.nodes.unshift(newNode);
      this.dialogAddCat = false;
      this.selectedLibelle = "";
      this.newLibelle = "";
      this.enrNodes();

      // pour gestion produit
      // a isoler avec une conditionnelle si dedans gestion catégories
      if (this.fiche) {
        this.$emit("onCategoriesChange", true);
      }
    },
    addSousCategorie() {
      this.dialogLoader = true;
      let slVueTree = this.$refs.slVueTree;
      const selectedNode = slVueTree.getSelected()[0];
      let newNode = {};
      newNode.title = this.newLibelle;
      newNode.slug = this.string_to_slug(this.newLibelle);
      newNode.isExpanded = true;
      newNode.children = [];
      selectedNode.children.push(newNode);
      let indiceCat = null;
      let indiceScat1 = null;
      let indiceScat2 = null;
      let indiceScat3 = null;
      let tabSize = selectedNode.path.length;
      for (var i = 0; i < tabSize; i++) {
        switch (i) {
          case 0:
            indiceCat = selectedNode.path[i];
            break;
          case 1:
            indiceScat1 = selectedNode.path[i];
            break;
          case 2:
            indiceScat2 = selectedNode.path[i];
            break;
          case 3:
            indiceScat3 = selectedNode.path[i];
            break;
        }
      }
      let nodeFullPath = "";
      switch (tabSize) {
        case 1:
          nodeFullPath = this.nodes[indiceCat];
          break;
        case 2:
          nodeFullPath = this.nodes[indiceCat].children[indiceScat1];
          break;
        case 3:
          nodeFullPath = this.nodes[indiceCat].children[indiceScat1].children[indiceScat2];
          break;
      }

      nodeFullPath.children.push(newNode);
      this.dialogAdd = false;
      this.selectedLibelle = "";
      this.newLibelle = "";
      this.enrNodes();

      // pour gestion produit
      // a isoler avec une conditionnelle si dedans gestion catégories
      if (this.fiche) {
        this.$emit("onCategoriesChange", true);
      }
    },

    enrNodes() {
      let temporaryModule = this.modulesCategories.slug;
      console.log("this.nodes", this.nodes);
      // return false;
      this.jsonNodes = JSON.stringify(this.nodes);
      let updateObj = {
        data: { categories: this.jsonNodes }
      };
      this.$axios
        .post(URL_UPDATE_CATEGORIES_LIST + temporaryModule, updateObj)
        .then(response => {
          this.dialogLoader = false;
        })
        .catch(error => {
          console.log("error = ", error);
          this.dialogLoader = false;
        });
    },
    toggleVisibility: function(event, node) {
      this.dialogLoader = true;
      const slVueTree = this.$refs.slVueTree;
      event.stopPropagation();
      const visible = !node.data || node.data.visible !== false;
      slVueTree.updateNode(node.path, { data: { visible: !visible } });
      this.lastEvent = `Node ${node.title} is ${visible ? "visible" : "invisible"} now`;
      this.enrNodes();
      if (this.fiche) {
        this.$emit("onCategoriesChange", true);
      }
    },

    nodeSelected(nodes, event) {
      this.selectedNodesTitle = nodes.map(node => node.title).join(", ");
      this.lastEvent = `Select nodes: ${this.selectedNodesTitle}`;
    },

    nodeDropped(nodes, position, event) {
      this.dialogLoader = true;
      this.lastEvent = `Nodes: ${nodes.map(node => node.title).join(", ")} are dropped ${position.placement} ${position.node.title}`;
      this.enrNodes();
      if (this.fiche) {
        this.$emit("onCategoriesChange", true);
      }
    },
    // slug des catégories
    string_to_slug(str) {
      str = str.replace(/^\s+|\s+$/g, ""); // trim
      str = str.toLowerCase();

      str = slugme(str);

      // // remove accents, swap ñ for n, etc
      // var from = "åàáãäâèéëêìíïîòóöôùúüûñç·/_,:;.";
      // var to = "aaaaaaeeeeiiiioooouuuunc-------";

      // for (var i = 0, l = from.length; i < l; i++) {
      //   str = str.replace(new RegExp(from.charAt(i), "g"), to.charAt(i));
      // }
      str = str
        .replace(/[^a-z0-9 -]/g, "") // remove invalid chars
        .replace(/\s+/g, "-") // collapse whitespace and replace by -
        .replace(/-+/g, "-") // collapse dashes
        .replace(/^-+/, "") // trim - from start of text
        .replace(/-+$/, ""); // trim - from end of text

      return str;
    }
  }
};
</script>
<style>
.sl-vue-tree {
  position: relative;
  cursor: default;
  -webkit-touch-callout: none;
  -webkit-user-select: none;
  -khtml-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
}

.sl-vue-tree.sl-vue-tree-root {
  border: 1px solid rgba(9, 22, 29, 0.027);
  background-color: rgba(9, 22, 29, 0.041);
  color: rgb(0, 0, 0);
  border-radius: 3px;
}

.sl-vue-tree-root > .sl-vue-tree-nodes-list {
  overflow: hidden;
  position: relative;
  padding-bottom: 4px;
}

.sl-vue-tree-selected > .sl-vue-tree-node-item {
  /* background-color: #13242d; */
  background-color: #eb4177;
  color: white;
}

.sl-vue-tree-selected > .sl-vue-tree-node-item:hover {
  background-color: #2576d2;
  color: white;
}

.sl-vue-tree-node-item:hover,
.sl-vue-tree-node-item.sl-vue-tree-cursor-hover {
  color: #eb4177;
}

.sl-vue-tree-node-item {
  position: relative;
  display: flex;
  flex-direction: row;
  justify-content: center;
  align-items: center;

  padding-left: 10px;
  padding-right: 10px;
  line-height: 28px;
  /* border: 1px solid transparent; */
  border-bottom: 1px solid #ccc;
}

.sl-vue-tree-node-item.sl-vue-tree-cursor-inside {
  /* border: 1px solid rgba(255, 255, 255, 0.5); */
  border: 1px solid #eb4177;
}

.sl-vue-tree-gap {
  width: 25px;
  min-height: 1px;
}

.sl-vue-tree-toggle {
  display: inline-block;
  float: left;

  /* width: 20px; */

  margin-top: 5px;
  margin-right: 5px;
  display: flex;
  justify-content: center;
  align-items: left;
}

.sl-vue-tree-sidebar {
  margin-left: auto;
}

.sl-vue-tree-cursor {
  position: absolute;
  /* border: 1px solid rgba(255, 255, 255, 0.5); */
  border: 1px solid #eb4177;
  height: 1px;
  width: 100%;
}

.categorie-ligne-name {
  width: 50%;
  float: left;
  display: flex;
  justify-content: left;
  align-items: center;
}

.categorie-ligne-name i {
  margin-right: 5px;
}

.categorie-ligne-actions {
  width: auto;
  float: right;
  text-align: right;
}
.sl-vue-tree-title {
  text-align: left;
  width: 100%;
}
</style>
